subs = {
  'all' : [ ## Special key: Changes are applied to all applicable conversions automatically
    [None,None]
  ],
  'mixed' : [
    ['zc','ds'],
    ('ZC','DS'),
    ('zc','ds'),
    ('PLASMA_Complex64_t','double'),
    ('PLASMA_Complex32_t','float'),
    ('PlasmaComplexDouble','PlasmaRealDouble'),
    ('PlasmaComplexFloat','PlasmaRealFloat'),
    ('zlange','dlange'),
    ('zlag2c','dlag2s'),
    ('clag2z','slag2d'),
    ('zlacpy','dlacpy'),
    ('zgemm','dgemm'),
    ('zherk','dsyrk'),
    ('zher2k','dsyr2k'),
    ('zlansy','dlansy'),
    ('zaxpy','daxpy'),
    ('pzgetrf','pdgetrf'),
    ('pcgetrf','psgetrf'),
    ('ztrsm','dtrsm'),
    ('ctrsm','strsm'),
    ('CBLAS_SADDR',''),
    ('zlarnv','dlarnv'),
    ('zgesv','dgesv'),
    ('zhemm','dsymm'),
    ('zlanhe','dlansy'),
    ('zlaghe','dlagsy'),
    ('ztrmm','dtrmm'),
    ('ctrmm','strmm'),
    ('Conj',''),
    ('zpotrf','dpotrf'),
    ('cpotrf','spotrf'),
    ('PLASMA_Alloc_Workspace_zgels','PLASMA_Alloc_Workspace_dgels'),
    ('plasma_pc',    'plasma_ps'),
    ('plasma_pz',    'plasma_pd'),
    ('plasma_coop',  'plasma_soop'),
    ('plasma_zoop',  'plasma_doop'),
    ('plasma_cip',   'plasma_sip'),
    ('plasma_zip',   'plasma_dip'),
    ('plasma_cdesc', 'plasma_sdesc'),
    ('plasma_zdesc', 'plasma_ddesc'),
    ('unmqr','ormqr'),
    ('unmlq','ormlq'),
  ],
  'normal' : [ ## Dictionary is keyed on substitution type
    ['s','d','c','z'], ## Special Line Indicating type columns
    ('float',                'double',               'cuFloatComplex',      'cuDoubleComplex'    ),
    ('#define PRECISION_s',  '#define PRECISION_d',  '#define PRECISION_c', '#define PRECISION_z'),
    ('#undef PRECISION_s',   '#undef PRECISION_d',   '#undef PRECISION_c',  '#undef PRECISION_z' ),
    ('#define REAL',         '#define REAL',         '#define COMPLEX',     '#define COMPLEX'    ),
    ('#undef COMPLEX',       '#undef COMPLEX',       '#undef REAL',         '#undef REAL'        ),
    ('#define SINGLE',       '#define DOUBLE',       '#define SINGLE',      '#define DOUBLE'     ),
    ('#undef DOUBLE',        '#undef SINGLE',        '#undef DOUBLE',       '#undef SINGLE'      ),
    ('Workspace_s',          'Workspace_d',          'Workspace_c',         'Workspace_z'        ),
    ('workspace_s',          'workspace_d',          'workspace_c',         'workspace_z'        ),
    ('cublasS',              'cublasD',              'cublasC',             'cublasZ'            ),
    ('codelet_s',            'codelet_d',            'codelet_c',           'codelet_z'          ),
    ('CODELETS_S',           'CODELETS_D',           'CODELETS_C',          'CODELETS_Z'         ),
    ('SCODELETS',            'DCODELETS',            'CCODELETS',           'ZCODELETS'          ),
    ('wrapper_s',            'wrapper_d',            'wrapper_c',           'wrapper_z'          ),
    ('WRAPPER_S',            'WRAPPER_D',            'WRAPPER_C',           'WRAPPER_Z'          ),
    ('morse_s',              'morse_d',              'morse_c',             'morse_z'            ),
    ('MORSE_S',              'MORSE_D',              'MORSE_C',             'MORSE_Z'            ),
    ('morse_ps',             'morse_pd',             'morse_pc',            'morse_pz'           ),
    ('magma_starpu_s',       'magma_starpu_d',       'magma_starpu_c',      'magma_starpu_z'     ),
    ('MAGMA_S',              'MAGMA_D',              'MAGMA_C',             'MAGMA_Z'            ),
    ('MAGMA_s',              'MAGMA_d',              'MAGMA_c',             'MAGMA_z'            ),
    ('magma_s',              'magma_d',              'magma_c',             'magma_z'            ),
    ('magma_ps',             'magma_pd',             'magma_pc',            'magma_pz'           ),
    ('profile_s',            'profile_d',            'profile_c',           'profile_z'          ),
    ('PROFILE_S',            'PROFILE_D',            'PROFILE_C',           'PROFILE_Z'          ),
    ('cl_s',                 'cl_d',                 'cl_c',                'cl_z'               ),
    ('cl_ps',                'cl_pd',                'cl_pc',               'cl_pz'              ),
    ('ipt_s','ipt_d','ipt_c','ipt_z'),
    ('cblas_sasum','cblas_dasum','cblas_scasum','cblas_dzasum'),
    ('CORE_sasum','CORE_dasum','CORE_scasum','CORE_dzasum'),
    ('core_sasum','core_dasum','core_scasum','core_dzasum'),
    ('coreblas_s','coreblas_d','coreblas_c','coreblas_z'),
    ('LAPACKE_s','LAPACKE_d','LAPACKE_c','LAPACKE_z'),
    ('slag2d','dlag2s','clag2z','zlag2c'),
    ('saxpy','daxpy','caxpy','zaxpy'),
    ('ssymm','dsymm','chemm','zhemm'),
    ('SSYMM','DSYMM','CHEMM','ZHEMM'),
    ('ssyrk','dsyrk','cherk','zherk'),
    ('SSYRK','DSYRK','CHERK','ZHERK'),
    ('ssyr2k','dsyr2k','cher2k','zher2k'),
    ('SSYR2K','DSYR2K','CHER2K','ZHER2K'),
    ('sgesv','dgesv','cgesv','zgesv'),
    ('SUNGESV','SUNGESV','CUNGESV','CUNGESV'),
    ('SGESV','SGESV','CGESV','CGESV'),
    ('SGESV','DGESV','CGESV','ZGESV'),
    ('sgels','dgels','cgels','zgels'),
    ('SGELS','DGELS','CGELS','ZGELS'),
    ('sgemm','dgemm','cgemm','zgemm'),
    ('SGEMM','DGEMM','CGEMM','ZGEMM'),
    ('sposv','dposv','cposv','zposv'),
    ('SPOSV','SPOSV','CPOSV','CPOSV'),
    ('SPOSV','DPOSV','CPOSV','ZPOSV'),
    ('ssymm','dsymm','csymm','zsymm'),
    ('SSYMM','DSYMM','CSYMM','ZSYMM'),
    ('ssyrk','dsyrk','csyrk','zsyrk'),
    ('SSYRK','DSYRK','CSYRK','ZSYRK'),
    ('ssyr2k','dsyr2k','csyr2k','zsyr2k'),
    ('SSYR2K','DSYR2K','CSYR2K','ZSYR2K'),
    ('strmm','dtrmm','ctrmm','ztrmm'),
    ('STRMM','DTRMM','CTRMM','ZTRMM'),
    ('strsm','dtrsm','ctrsm','ztrsm'),
    ('STRSM','DTRSM','CTRSM','ZTRSM'),
    ('sgelq2','dgelq2','cgelq2','zgelq2'),
    ('sgelqf','dgelqf','cgelqf','zgelqf'),
    ('sgelqfrh','dgelqfrh','cgelqfrh','zgelqfrh'),
    ('SGELQF','DGELQF','CGELQF','ZGELQF'),
    ('sgelqs','dgelqs','cgelqs','zgelqs'),
    ('SGELQS','DGELQS','CGELQS','ZGELQS'),
    ('sgeqr2','dgeqr2','cgeqr2','zgeqr2'),
    ('sgeqrf','dgeqrf','cgeqrf','zgeqrf'),
    ('sgeqrfrh','dgeqrfrh','cgeqrfrh','zgeqrfrh'),
    ('SGEQRF','DGEQRF','CGEQRF','ZGEQRF'),
    ('sgeqrs','dgeqrs','cgeqrs','zgeqrs'),
    ('SGEQRS','DGEQRS','CGEQRS','ZGEQRS'),
    ('sgetf2','dgetf2','cgetf2','zgetf2'),
    ('sgetrl','dgetrl','cgetrl','zgetrl'),
    ('sgetrf','dgetrf','cgetrf','zgetrf'),
    ('SGETRF','DGETRF','CGETRF','ZGETRF'),
    ('sgessm','dgessm','cgessm','zgessm'),
    ('sgeqrt','dgeqrt','cgeqrt','zgeqrt'),
    ('sssssm','dssssm','cssssm','zssssm'),
    ('stsmqr','dtsmqr','ctsmqr','ztsmqr'),
    ('stsqrt','dtsqrt','ctsqrt','ztsqrt'),
    ('ststrf','dtstrf','ctstrf','ztstrf'),
    ('sgetrs','dgetrs','cgetrs','zgetrs'),
    ('SGETRS','DGETRS','CGETRS','ZGETRS'),
    ('slacgv','dlacgv','clacgv','zlacgv'),
    ('slacpy','dlacpy','clacpy','zlacpy'),
    ('slagsy','dlagsy','claghe','zlaghe'),
    ('slagsy','dlagsy','clagsy','zlagsy'),
    ('SLANGE','DLANGE','CLANGE','ZLANGE'),
    ('SLANSY','DLANSY','CLANHE','ZLANHE'),
    ('SLANSY','DLANSY','CLANSY','ZLANSY'),
    ('SLANTR','DLANTR','CLANTR','ZLANTR'),
    ('slange','dlange','clange','zlange'),
    ('slansy','dlansy','clanhe','zlanhe'),
    ('slansy','dlansy','clansy','zlansy'),
    ('slantr','dlantr','clantr','zlantr'),
    ('slarfb','dlarfb','clarfb','zlarfb'),
    ('slarfg','dlarfg','clarfg','zlarfg'),
    ('slarft','dlarft','clarft','zlarft'),
    ('slarnv','dlarnv','clarnv','zlarnv'),
    ('slaswp','dlaswp','claswp','zlaswp'),
    ('splgsy','dplgsy','cplghe','zplghe'),
    ('spotrf','dpotrf','cpotrf','zpotrf'),
    ('spotrf','dpotrf','cpotrf','zpotrf'),
    ('SPOTRF','DPOTRF','CPOTRF','ZPOTRF'),
    ('spotrs','dpotrs','cpotrs','zpotrs'),
    ('SPOTRS','DPOTRS','CPOTRS','ZPOTRS'),
    ('sorglq','dorglq','cunglq','zunglq'),
    ('sorglqrh','dorglqrh','cunglqrh','zunglqrh'),
    ('SORGLQ','DORGLQ','CUNGLQ','ZUNGLQ'),
    ('sorgqr','dorgqr','cungqr','zungqr'),
    ('sorgqrrh','dorgqrrh','cungqrrh','zungqrrh'),
    ('SORGQR','DORGQR','CUNGQR','ZUNGQR'),
    ('sormlq','dormlq','cunmlq','zunmlq'),
    ('sormlqrh','dormlqrh','cunmlqrh','zunmlqrh'),
    ('SORMLQ','DORMLQ','CUNMLQ','ZUNMLQ'),
    ('sormqr','dormqr','cunmqr','zunmqr'),
    ('sormqrrh','dormqrrh','cunmqrrh','zunmqrrh'),
    ('SORMQR','DORMQR','CUNMQR','ZUNMQR'),
    ('slamch','dlamch','slamch','dlamch'),
    ('slarnv','dlarnv','slarnv','dlarnv'),
    ('slauum','dlauum','clauum','zlauum'),
    ('spotri','dpotri','cpotri','zpotri'),
    ('strtri','dtrtri','ctrtri','ztrtri'),
    ('sshift','dshift','cshift','zshift'),
    ('sgetmo','dgetmo','cgetmo','zgetmo'),
    ('sgetmi','dgetmi','cgetmi','zgetmi'),
    ('SGETMI','DGETMI','CGETMI','ZGETMI'),
    ('sgecfi','dgecfi','cgecfi','zgecfi'),
    ('SGECFI','DGECFI','CGECFI','ZGECFI'),
    ('spack','dpack','cpack','zpack'),
    ('strsmpl','dtrsmpl','ctrsmpl','ztrsmpl'),
    ('STRSMPL','DTRSMPL','CTRSMPL','ZTRSMPL'),
    ('splgsy','dplgsy','cplghe','zplghe'),
    ('splgsy','dplgsy','cplgsy','zplgsy'),
    ('splrnt','dplrnt','cplrnt','zplrnt'),
    ('sprofiling','dprofiling','cprofiling','zprofiling'),
    ('slocality','dlocality','clocality','zlocality'),
    ('\*\*T','\*\*T','\*\*H','\*\*H'),
    ('BLAS_s','BLAS_d','BLAS_s','BLAS_d'),
    ('BLAS_s','BLAS_d','BLAS_c','BLAS_z'),
    ('fabsf','fabs','cabsf','cabs'),
    ('imagf','imag','imagf','imag'),
    ('cblas_is','cblas_id','cblas_ic','cblas_iz'),
    ('cblas_s','cblas_d','cblas_c','cblas_z'),
    ('','','CBLAS_SADDR','CBLAS_SADDR'),
    ('CblasTrans','CblasTrans','CblasConjTrans','CblasConjTrans'),
    ('REAL','DOUBLE_PRECISION','COMPLEX','COMPLEX_16'),
    ('','','conjf','conj'),
    ('CORE_S','CORE_D','CORE_C','CORE_Z'),
    ('CORE_s','CORE_d','CORE_c','CORE_z'),
    ('CORE_s','CORE_d','CORE_s','CORE_d'),
    ('core_s','core_d','core_c','core_z'),
    ('float','double','float _Complex','double _Complex'),
    ('float','double','float','double'),
    ('example_s','example_d','example_c','example_z'),
    ('lapack_s','lapack_d','lapack_c','lapack_z'),
    ('lapack_slamch','lapack_dlamch','lapack_slamch','lapack_dlamch'),
    ('float','double','PLASMA_Complex32_t','PLASMA_Complex64_t'),
    ('plasma_ps','plasma_pd','plasma_pc','plasma_pz'),
    ('float','double','PLASMA_voidComplex32_t','PLASMA_voidComplex64_t'),
    ('PLASMA_s','PLASMA_d','PLASMA_c','PLASMA_z'),
    ('PLASMA_S','PLASMA_D','PLASMA_C','PLASMA_Z'),
    ('plasma_s','plasma_d','plasma_c','plasma_z'),
    ('control_s','control_d','control_c','control_z'),
    ('compute_s','compute_d','compute_c','compute_z'),
    ('PLASMA_sor','PLASMA_dor','PLASMA_cun','PLASMA_zun'),
    ('PlasmaRealFloat','PlasmaRealDouble','PlasmaComplexFloat','PlasmaComplexDouble'),
    ('PlasmaTrans','PlasmaTrans','PlasmaConjTrans','PlasmaConjTrans'),
    ('testing_ds','testing_ds','testing_zc','testing_zc'),
    ('time_s','time_d','time_c','time_z'),
    ('testing_s','testing_d','testing_c','testing_z'),
    ('TESTING_S','TESTING_D','TESTING_C','TESTING_Z'),
    ('stesting','dtesting','ctesting','ztesting'),
    ('SAUXILIARY','DAUXILIARY','CAUXILIARY','ZAUXILIARY'),
    ('sauxiliary','dauxiliary','cauxiliary','zauxiliary'),
    ('scheck','dcheck','ccheck','zcheck'),
    ('ger','ger','gerc','gerc'),
    ('ger','ger','geru','geru'),
    ('symm','symm','hemm','hemm'),
    ('syrk','syrk','herk','herk'),
    ('syr2k','syr2k','her2k','her2k'),
    ('lansy','lansy','lanhe','lanhe'),
    ('plgsy','plgsy','plghe','plghe'),
    ('stile','dtile','ctile','ztile'),
    ('ormqr','ormqr','unmqr','unmqr'),
  ],
  'tracing' : [
    ['plain','tau'],
    ('(\w+\*?)\s+(\w+)\s*\(([a-z* ,A-Z_0-9]*)\)\s*{\s+(.*)\s*#pragma tracing_start\s+(.*)\s+#pragma tracing_end\s+(.*)\s+}',r'\1 \2(\3){\n\4tau("\2");\5tau();\6}'),
    ('\.c','.c.tau'),
  ],
};
